unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, LCLType, StdCtrls, ComCtrls, Types, Math,

  {$ifdef arm}
  dglOpenGLSE,
  {$else}
  dglOpenGL,
  {$endif}

  Mesh, MyMath, Rad, Zylinder, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CoolBar1: TCoolBar;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    Timer1: TTimer;
    ToggleBoxTimer: TToggleBox;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonWinkelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure OpenGLControl1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  public
    BildPara: record
      zoom, x, y, xalt, yalt: single;
    end;

    Mesh: TMesh;

    TreibRad: record
      Richtung: (fwd, rwd);
      Radius, AufkeilWinkel: single;
      Rad: TRad;
      GegenKurbelRadius, TreibZapfenRadius: single;
    end;

    Schubstange: record
      ZylinderAbstand: single;
      KuppelStange, Treibstange, KolbenStange: TStange;
      Kolben: TKolben
    end;

    SchiebeZylinder: record
      Top: single;
      Kolben: TKolben;
      SchieberStange: TStange;
    end;

    SchwingenGestaenge: record
      Schwinge_xy, HaengeEisen_xy: TPointF;
      SchwingenStange, Schwinge, SchieberSchubstange, HaengeEisen: TStange;
      HaengeEisenPos: record
        ZHubPos, mindesHub,
        min, max, Hub, HubPos: single;
      end;
    end;

    Voreilhebel: record
      Lenkeransatz_Height: single;
      Lenkeransatz,
      Lenkstange, VoreilHebel, StangeSchieberTop: TStange;
      KnieHbl: TSchubKurbel;
    end;

    RadAbstand, speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation

const
  m = 108.0;


{ TForm1 }

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if ToggleBoxTimer.Checked then begin
    if TreibRad.Richtung = rwd then begin
      winkel += speed;
      if winkel > 360 then begin
        winkel -= 360;
      end;
    end else begin
      winkel -= speed;
      if winkel < 0 then begin
        winkel += 360;
      end;
    end;
  end;

  OpenGLControl1.Repaint;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  with  SchwingenGestaenge do begin
    HaengeEisen_xy.y := SchiebeZylinder.Top + HaengeEisen.Laenge + ScrollBar1.Position + m;
    with  HaengeEisenPos do begin
      HubPos := ScrollBar1.Position;
      if HaengeEisenPos.HubPos > 0 then begin
        TreibRad.Richtung := rwd;
      end else begin
        TreibRad.Richtung := fwd;
      end;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  ReadExtensions;
  ReadImplementationProperties;
  OpenGLControl1.MakeCurrent;

  with BildPara do begin
    zoom := 0.001;
  end;

  with TreibRad do begin
    Radius := 500.0;
    TreibZapfenRadius := 233;
    GegenKurbelRadius := 215;
    AufkeilWinkel := -90.0;

    Rad := TRad.Create(Radius);
    RadAbstand := 1200.0;
  end;

  SchiebeZylinder.Top := 500.0;

  with Schubstange do begin
    KuppelStange := TStange.Create(TreibRad.Radius / 8, RadAbstand, vec3(1.0, 0.2, 0.2));
    Treibstange := TStange.Create(TreibRad.Radius / 8, 2850, vec3(1.0, 0.2, 0.2));
    KolbenStange := TStange.Create(TreibRad.Radius / 8, TreibRad.TreibZapfenRadius * 2, vec3(1.0, 0.2, 0.2));
    Kolben := TKolben.Create(TreibRad.TreibZapfenRadius * 2, 200);
    ZylinderAbstand := Treibstange.Laenge;
  end;

  with SchwingenGestaenge do begin
    HaengeEisen_xy.x := 2050 - 440;

    with Schwinge_xy do begin
      x := 1890 + 50;  // (1890)
      y := 500 + m;
    end;

    SchwingenStange := TStange.Create(TreibRad.Radius / 12, 1937.9, vec3(0.2, 1.0, 0.2));
    Schwinge := TStange.Create(TreibRad.Radius / 6, 405, vec3(0.2, 0.2, 1.0));

    SchieberSchubstange := TStange.Create(TreibRad.Radius / 12, 1400 + 200, vec3(1.0, 0.2, 0.2));
    HaengeEisen := TStange.Create(TreibRad.Radius / 12, 500, vec3(1.0, 0.2, 0.2));

    with HaengeEisenPos do begin
      min := -300;
      max := 300;
      Hub := max - min;
      mindesHub := 50;

      //      HubPos := max;
      HubPos := 0;
      ScrollBar1.Min := round(min);
      ScrollBar1.Max := round(max);
      ScrollBar1.Position := round(HubPos);
      ScrollBar1Change(Sender);
    end;
  end;

  with Voreilhebel do begin
    Lenkeransatz_Height := 195;
    VoreilHebel := TStange.Create(TreibRad.Radius / 12, 725, vec3(1.0, 0.2, 0.2));
    Lenkstange := TStange.Create(TreibRad.Radius / 12, 441, vec3(1.0, 0.2, 0.2));
    Lenkeransatz := TStange.Create(TreibRad.Radius / 12, Lenkeransatz_Height, vec3(1.0, 0.2, 0.2));
    StangeSchieberTop := TStange.Create(TreibRad.Radius / 12, m, vec3(1.0, 0.2, 0.2));
  end;

  with SchiebeZylinder do begin
    Kolben := TKolben.Create(TreibRad.GegenKurbelRadius * 2, 100);
    SchieberStange := TStange.Create(TreibRad.Radius / 12, TreibRad.GegenKurbelRadius * 2, vec3(1.0, 0.2, 0.2));
  end;

  Mesh := TMesh.Create;

  speed := 3.10344;

  Trigo.Grad := True;
  Timer1.Enabled := True;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  ExzenterTreibStange_xy, ExzenterSchwinge_xy: TPointf;
  SchieberHubPos, KKopf_x, p2, w, h, KKopfSchieber: single;
  VierGelenk1, VierGelenk2: TKurbelSchwinge;

begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  BackGround;

  // --- Bremsklötze

  with TreibRad do begin
    glTranslatef(-RadAbstand * 2, 0.0, 0.0);
    Mesh.Arc2(Radius * 1.2, Radius * 1.4, 0, 60); // deutet eine VierGelenk2 an
    glColor3f(1, 1, 1);
    Mesh.Arc2(Radius * 1.2, Radius * 1.4, 90, 180.0); // deutet eine VierGelenk2 an
    glColor3f(1, 0.1, 1);
    if winkel < 180.0 then begin
      glRotatef(winkel / 10, 0.0, 0.0, 1.0);
    end else begin
      glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
    end;
    Mesh.Arc2(Radius * 1.4, Radius * 1.6, -30, 30); // deutet eine VierGelenk2 an

    glLoadIdentity();
  end;

  // --- Treibrad


  with TreibRad do begin
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);

    glLoadIdentity();
  end;


  with Schubstange do begin
    glTranslatef(0, 0, -0.03);

    // --- TreibStange

    ExzenterTreibStange_xy := Trigo.Alpha_c_To_xy(winkel, TreibRad.TreibZapfenRadius);

    glTranslatef(ExzenterTreibStange_xy.x, ExzenterTreibStange_xy.y, 0);

    glPushMatrix;
    glTranslatef(-RadAbstand, 0.0, 0.0);
    KuppelStange.Draw;
    glTranslatef(-RadAbstand, 0.0, 0.0);
    KuppelStange.Draw;
    glPopMatrix;

    // --- Treibstange

    glRotatef(-Trigo.a_c_To_Alpha(ExzenterTreibStange_xy.y, Treibstange.Laenge), 0.0, 0.0, 1.0);
    Treibstange.Draw;
    glLoadIdentity();


    // --- Kolben

    KKopf_x := sqrt(sqr(Treibstange.Laenge) - sqr(ExzenterTreibStange_xy.y)) + ExzenterTreibStange_xy.x;

    glTranslatef(KKopf_x, 0.0, 0.0);
    KolbenStange.Draw;
    glLoadIdentity();

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, 0.0, 0.0);

    SchieberHubPos := KKopf_x - Treibstange.Laenge + TreibRad.TreibZapfenRadius;
    Kolben.Draw(SchieberHubPos);
    glLoadIdentity();

    // Kolben Schieber


    if TreibRad.Richtung = fwd then begin
      ExzenterSchwinge_xy := Trigo.Alpha_c_To_xy(winkel + TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius);
    end else begin
      ExzenterSchwinge_xy := Trigo.Alpha_c_To_xy(winkel - TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius);
    end;

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, SchiebeZylinder.Top, 0.0);

    with SchwingenGestaenge.HaengeEisenPos do begin
      w := (abs(HubPos / max * (max - mindesHub)) + mindesHub) / Hub * 2;
    end;


    p2 := sqrt(sqr(Treibstange.Laenge) - sqr(ExzenterSchwinge_xy.y * w)) + ExzenterSchwinge_xy.x * w;
    SchieberHubPos := p2 - Treibstange.Laenge + TreibRad.TreibZapfenRadius - (TreibRad.TreibZapfenRadius - TreibRad.GegenKurbelRadius);

    SchiebeZylinder.Kolben.Draw(SchieberHubPos);

    glLoadIdentity();
    KKopfSchieber := p2 + SchiebeZylinder.SchieberStange.Laenge;

  end;

  // --- Voreilhebel

  with Voreilhebel do begin
    KnieHbl.SetParam(PointF(KKopf_x, -Lenkeransatz_Height), PointF(KKopfSchieber, SchiebeZylinder.Top), Lenkstange.Laenge, VoreilHebel.Laenge, True);
    glTranslatef(KKopf_x, 0, 0);

    glPushMatrix;
    glRotatef(-90, 0.0, 0.0, 0.1);
    Lenkeransatz.Draw;
    glPopMatrix;

    glTranslatef(0.0, -Lenkeransatz_Height, 0.0);


    glRotatef(KnieHbl.Stange1_W, 0.0, 0.0, 0.1);
    Lenkstange.Draw;
    glLoadIdentity();

    glTranslatef(KKopfSchieber, SchiebeZylinder.Top, 0);
    glRotatef(KnieHbl.Stange2_W, 0.0, 0.0, 0.1);
    VoreilHebel.Draw;
    glTranslatef(-StangeSchieberTop.Laenge, 0.0, 0.0);
    StangeSchieberTop.Draw;
    glLoadIdentity();
  end;


  // --- SchwingenGestaenge ---

  with SchwingenGestaenge do begin

    VierGelenk1.SetParam(Voreilhebel.KnieHbl.Stange2_W + 180, Voreilhebel.StangeSchieberTop.Laenge,
      PointF(-KKopfSchieber + HaengeEisen_xy.x, -SchiebeZylinder.Top + HaengeEisen_xy.y),
      SchieberSchubstange.Laenge, HaengeEisen.Laenge);


    // Pleuel

    glPushMatrix;
    glTranslatef(VierGelenk1.RadExzenter.x + KKopfSchieber, VierGelenk1.RadExzenter.y + SchiebeZylinder.Top, -0.2);
    glRotatef(VierGelenk1.Pleuel_W, 0.0, 0.0, 1.0);
    SchieberSchubstange.Draw;
    glPopMatrix;

    with HaengeEisen_xy do begin
      glTranslatef(x, y, -0.2);
    end;

    glRotatef(VierGelenk1.Schwinge_W, 0.0, 0.0, 1.0);
    HaengeEisen.Draw;
    glLoadIdentity();

  end;

  // --- SchiebeZylinder


  glTranslatef(KKopfSchieber, SchiebeZylinder.Top, -0.2);
  SchiebeZylinder.SchieberStange.Draw;
  glLoadIdentity();

  // --- Schwinge ---

  with SchwingenGestaenge do begin
    with Schwinge_xy do begin
      VierGelenk2.SetParam(winkel + TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius, PointF(x, y),
        SchwingenStange.Laenge, Schwinge.Laenge, True);
    end;


    // Schwingenstange

    glTranslatef(VierGelenk2.RadExzenter.x, VierGelenk2.RadExzenter.y, -0.2);
    glRotatef(VierGelenk2.Pleuel_W, 0.0, 0.0, 1.0);
    SchwingenStange.Draw;
    glLoadIdentity();

    // Schwinge

    with Schwinge_xy do begin
      glTranslatef(x, y, -0.2);
      glRotatef(VierGelenk2.Schwinge_W, 0.0, 0.0, 1.0);
      Schwinge.Draw;
      glRotatef(180, 0.0, 0.0, 1.0);
      Schwinge.Draw;
      glLoadIdentity();
    end;

  end;

  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with TreibRad do begin
    Rad.Free;
  end;

  with  SchiebeZylinder do begin
    Kolben.Free;
    SchieberStange.Free;
  end;

  with Schubstange do begin
    KuppelStange.Free;
    Treibstange.Free;
    KolbenStange.Free;
    Kolben.Free;
  end;

  with SchwingenGestaenge do begin
    SchieberSchubstange.Free;
    HaengeEisen.Free;
    SchwingenStange.Free;
    Schwinge.Free;
  end;

  with Voreilhebel do begin
    Lenkeransatz.Free;
    Lenkstange.Free;
    VoreilHebel.Free;
    StangeSchieberTop.Free;
  end;

  Mesh.Free;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);

    with BildPara do begin
      glTranslatef(BildPara.x, BildPara.y, 0.0);
      glScalef(zoom, zoom, zoom);
    end;
  end;
end;

procedure TForm1.OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
const
  Step = 0.0050;
begin
  if Shift = [ssLeft] then begin
    BildPara.x += (X - BildPara.xalt) * Step;
    BildPara.y += -(Y - BildPara.yalt) * Step;
    OpenGLControl1Resize(Sender);
  end;
  BildPara.xalt := x;
  BildPara.yalt := y;
end;

procedure TForm1.OpenGLControl1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom *= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.OpenGLControl1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom /= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

procedure TForm1.ButtonWinkelClick(Sender: TObject);
begin
  case TButton(Sender).Tag of
    0: begin
      winkel := 0;
    end;
    90: begin
      winkel := 90;
    end;
    180: begin
      winkel := 180;
    end;
    270: begin
      winkel := 270;
    end;
  end;

end;

initialization

  {$I unit1.lrs}

end.
